//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitry Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

#ifndef SlyDimanH
#define SlyDimanH

#include <limits.h>

//---------------------------------------------------------------------------
#define sgn(a)  ((a < 0) ? (-1) : ((a > 0) ? (1) : (0)))

#define SWAP(a,b)  { int tmp = a; a = b; b = tmp; }

//---------------------------------------------------------------------------
typedef   unsigned int     uint;
typedef   unsigned long    ulong;
typedef   unsigned short   ushort;
typedef   unsigned char    uchar;

//---------------------------------------------------------------------------
#define ShortTruncate(a)    (((a) > SHRT_MAX) ? SHRT_MAX : (((a) < SHRT_MIN) ? SHRT_MIN : (a)))
#define UcharTruncate(a)    (((a) > UCHAR_MAX) ? UCHAR_MAX : (((a) < 0) ? 0 : (a)))
#define CharTruncate(a)     (((a) > SCHAR_MAX) ? SCHAR_MAX : (((a) < SCHAR_MIN) ? SCHAR_MIN : (a)))
#define ShortToUchar(a)     ((unsigned char)((((unsigned short)((short)(a))) >> 8) ^ 0x80))
#define UcharToShort(a)     ((short)((unsigned short)((a) ^ 0x80) << 8))
#define UcharToInt(a)       ((int)((a) ^ 0x80))
#define TruncateToUchar(a)  ShortToUchar( ShortTruncate( a ) )

//---------------------------------------------------------------------------
#define ClearIniFile(fs)   {                      \
    TStringList *Strings = new TStringList();     \
    fs->ReadSections( Strings );                  \
    for( int i=0; i < Strings->Count; i++ )       \
      fs->EraseSection( Strings->Strings[i] );    \
    delete Strings;        }                           

//---------------------------------------------------------------------------
unsigned short htoi( char * hexdata )
{
  char *tmp;
  return( (ushort)strtol( hexdata, &tmp, 16 ) );
}

unsigned long htol( char * hexdata )
{
  char *tmp;
  return( (ulong)strtoul( hexdata, &tmp, 16 ) );
}


//---------------------------------------------------------------------------
#endif     // SlyDimanH

