//---------------------------------------------------------------------------
#ifndef WinUtilsH
#define WinUtilsH

#include <Dialogs.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//---------------------------------------------------------------------------
namespace Winutils
{

//---------------------------------------------------------------------------
extern PACKAGE int SlyMsg( HWND hApp, DWORD dwFlags, LPSTR Caption, LPSTR sz,...);
extern PACKAGE int SlyErrMsg( HWND hApp, HRESULT hr, DWORD dwFlags, LPSTR Caption, LPSTR sz,...);

//---------------------------------------------------------------------------
extern PACKAGE HFONT __fastcall CreateRotatedFont(TFont* Font, int Angle);

//---------------------------------------------------------------------------

#define  WidthOf(R)  ((int)(R.Right - R.Left))

#define  HeightOf(R)  ((int)(R.Bottom - R.Top))

enum TFillDirection { fdTopToBottom, fdBottomToTop,
                      fdLeftToRight, fdRightToLeft };

extern PACKAGE void __fastcall GradientFillRect(TCanvas* Canvas,
                               TRect &ARect,
                               TColor StartColor,
                               TColor EndColor,
                               TFillDirection Direction,
                               int Colors);

//---------------------------------------------------------------------------
extern PACKAGE AnsiString __fastcall GetWindowsVersion();

extern PACKAGE void __fastcall ShowLastError( char *Caption );

}

//---------------------------------------------------------------------------
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Winutils;
#endif

#endif


